﻿function SimpleMessageBox
{
	Param
	(
		$MessageBoxInfo
	)
	
	$wshell = New-Object -ComObject Wscript.Shell
	$wshell.Popup("$MessageBoxInfo", 0, "Done", 0x1)
}

function FixOffice {
	$FindOSArchitecture = Get-WmiObject Win32_OperatingSystem | select OSArchitecture
	$OSArchitecture = "x86"

	$ProgramName = "OfficeClickToRun.exe"

	if ($FindOSArchitecture -match "64-bit")
	{
		$OSArchitecture = "x64"
	}
	else
	{
		$OSArchitecture = "x86"
	}

	$RepairTool = (Get-ItemProperty 'HKCU:\Software\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Compatibility Assistant\Store')


	$RepairTool.PSObject.Properties | ForEach-Object {
		If ($_.Name -like '*OfficeClickToRun*')
		{
			$OfficeRepairTool = "$_.Name".replace("=System.Byte[].Name", "").replace("byte[] ", "")
			$options = "scenario=Repair platform=$OSArchitecture forceappshutdown=True DisplayLevel=False"
			Invoke-Expression "& '$OfficeRepairTool' $options"
		}
		ElseIf ($_.Name -like '*integratedoffice*')
		{
			$OfficeRepairTool = "$_.Name".replace("=System.Byte[].Name", "").replace("byte[] ", "")
			$options = "RUNMODE RERUNMODE modetorun repair"
			Invoke-Expression "& '$OfficeRepairTool' $options"
		}
	}

	SimpleMessageBox -MessageBoxInfo "Please wait 10 minuets for all tasks to finish"
}
