﻿function SetDns{
    param(
        $DnsSettings,
        $Adapters
    )

    foreach($Adapter in $Adapters){
        
        $DnsInfo = Get-DNSClientServerAddress -InterfaceAlias $Adapter -AddressFamily IPv4
        
        if($DnsInfo.ServerAddresses -NotMatch $DnsSettings){

            Set-DNSClientServerAddress -InterfaceAlias $Adapter –ServerAddresses $DnsSettings

        }
        
    }
	
}

function pingTest{
	
	#$localIp = (Get-wmiObject Win32_networkAdapterConfiguration | ?{ $_.IPEnabled }).DefaultIPGateway
	$IpStatus = @{ }
	$localIp = Get-NetRoute -DestinationPrefix 0.0.0.0/0 | Select-Object -ExpandProperty Nexthop
	$exIp = "8.8.8.8"
	
	if ($localIp)
	{
		if (Test-Connection -Destination $localIp -Count 2 -Quiet)
		{
			$IpStatus.localIpStatus = "Local Network Available `n"
		}
		else
		{
			$IpStatus.localIpStatus = "No Local Network Available `n"
		}
	}
	else
	{
		$IpStatus.localIpStatus = "No Local Network Available `n"
	}
	
	if (Test-Connection -Destination $exIp -Count 2 -Quiet)
	{
		$IpStatus.exIpStatus = "External Network Available `n"
	}
	else
	{
		$IpStatus.exIpStatus = "No External Network Available `n"
	}
	
	return $IpStatus
	
}

function winsockReset{
	#-NoNewWindow
	start-process netsh -argumentList winsock, reset -windowStyle Hidden -wait -PassThru
	start-process netsh -argumentList int, ip, reset -windowStyle Hidden -wait -PassThru
	start-process ipconfig -argumentList /release -windowStyle Hidden -wait -PassThru
	start-process ipconfig -argumentList /renew -windowStyle Hidden -wait -PassThru
	start-process ipconfig -argumentList /flushdns -windowStyle Hidden -wait -PassThru
	
}

function dnsFlush{
	
	start-process ipconfig -argumentList /flushdns -windowStyle Hidden -wait -PassThru
	
}